#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2800one4xi.py">
#<abstract4xi abstract = "fires to direction one and to distance 2800"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2800one4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "

       
# -------------------------------------------------------------------------------------------------
# SHOT2ONE - COORDINATE SIGNS OF SHOOT2ONE4XI: (X + ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------  

global shot2one28004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings - copied from load2one4xi.py results to access faster by verb4xi.py
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False 


 
                         
# -------------------------------------------------------------------------------------------------
# 2800
# -------------------------------------------------------------------------------------------------                                          
shot2one28004xi = {
                  1:'0x0y2799z',
                  2:'0x1853y2098z',
                  3:'0x84y2798z',
                  4:'1030x1939y1736z',
                  5:'1032x1146y2336z',
                  6:'1033x1653y2009z',
                  7:'105x91y2796z',
                  8:'1074x1074y2351z',
                  9:'1086x2140y1441z',
                  10:'1097x2268y1219z',
                  11:'1106x1580y2029z',
                  12:'1111x1000y2366z',
                  13:'1121x1868y1758z',
                  14:'1144x926y2381z',
                  15:'1171x851y2396z',
                  16:'1175x1504y2048z',
                  17:'1189x2068y1465z',
                  18:'1207x1792y1780z',
                  19:'1208x2197y1245z',
                  20:'120x116y2794z',
                  21:'1238x1425y2067z',
                  22:'127x2504y1244z',
                  23:'1288x1990y1488z',
                  24:'1289x1712y1801z',
                  25:'1297x1343y2086z',
                  26:'12x334y2779z',
                  27:'1315x2120y1270z',
                  28:'133x143y2793z',
                  29:'1350x1259y2104z',
                  30:'1365x1628y1822z',
                  31:'1381x1908y1512z',
                  32:'1398x1173y2123z',
                  33:'1417x2038y1294z',
                  34:'1436x1541y1844z',
                  35:'1440x1085y2141z',
                  36:'144x171y2791z',
                  37:'1470x1821y1536z',
                  38:'1477x996y2159z',
                  39:'1501x1451y1865z',
                  40:'1514x1950y1319z',
                  41:'151x200y2788z',
                  42:'1553x1730y1559z',
                  43:'1561x1358y1885z',
                  44:'156x231y2786z',
                  45:'157x295y2779z',
                  46:'158x263y2783z',
                  47:'159x340y2875z',
                  48:'1605x1858y1344z',
                  49:'1615x1263y1906z',
                  50:'161x2322y1555z',
                  51:'1630x1635y1582z',
                  52:'1663x1166y1926z',
                  53:'1691x1762y1368z',
                  54:'16x22y2799z',
                  55:'1702x1537y1605z',
                  56:'1767x1436y1628z',
                  57:'1770x1662y1393z',
                  58:'1827x1332y1651z',
                  59:'1844x1558y1417z',
                  60:'184x2114y1826z',
                  61:'189x1801y2135z',
                  62:'1912x1450y1441z',
                  63:'218x2590y1040z',
                  64:'256x2482y1269z',
                  65:'27x306y2783z',
                  66:'280x1768y2153z',
                  67:'280x2295y1578z',
                  68:'292x2083y1847z',
                  69:'29x47y2799z',
                  70:'352x2564y1066z',
                  71:'367x1729y2170z',
                  72:'384x2452y1294z',
                  73:'397x2047y1868z',
                  74:'397x2262y1601z',
                  75:'39x2343y1532z',
                  76:'39x276y2786z',
                  77:'3x28y2799z',
                  78:'3x56y2799z',
                  79:'40x73y2798z',
                  80:'452x1687y2188z',
                  81:'483x2532y1092z',
                  82:'48x246y2788z',
                  83:'499x2005y1889z',
                  84:'49x100y2797z',
                  85:'509x2416y1319z',
                  86:'511x2222y1624z',
                  87:'532x1640y2205z',
                  88:'54x216y2791z',
                  89:'55x128y2796z',
                  90:'57x157y2794z',
                  91:'57x187y2793z',
                  92:'598x1958y1909z',
                  93:'610x1589y2222z',
                  94:'612x2492y1118z',
                  95:'622x2176y1647z',
                  96:'631x2373y1344z',
                  97:'683x1534y2239z',
                  98:'693x1906y1930z',
                  99:'730x2125y1669z',
                  100:'739x2446y1143z',
                  101:'74x2139y1805z',
                  102:'751x2324y1368z',
                  103:'752x1477y2256z',
                  104:'784x1849y1950z',
                  105:'817x1416y2272z',
                  106:'82x2608y1014z',
                  107:'834x2068y1692z',
                  108:'862x2393y1169z',
                  109:'866x2269y1392z',
                  110:'872x1787y1970z',
                  111:'878x1352y2289z',
                  112:'88x68y2797z',
                  113:'934x1285y2305z',
                  114:'934x2006y1714z',
                  115:'954x1722y1990z',
                  116:'95x1830y2116z',
                  117:'978x2207y1417z',
                  118:'981x2334y1194z',
                  119:'985x1217y2321z'}

#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2800one4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2800one4xi(queue2one, consumer_channel2one, publisher_channel2one):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2800ONE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2800ONE4XI -  QUEUE2ONE: ", queue2one)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2800ONE4XI -  CONSUMER_CHANNEL2ONE: ", consumer_channel2one)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2800ONE4XI -  PUBLISHER_CHANNEL2ONE: ", publisher_channel2one)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2800ONE4XI - TRYING TO RETURN BY PUTTING SHOT2ONE28004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2one.put(shot2one28004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2800ONE4XI - SUCCEEDED TO PUT SHOT2ONE28004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
            # SUCCEEDED TO PUT SHOT2ONE28004XI TO QUEUE2ONE:  <queue4xi.Queue4Xi object at 0x02AF7090>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2800ONE4XI *** FAILED TO PUT SHOT2ONE28004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2800ONE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi())
        #
         
    if ack2put is True:
        message2send4one = "<ack2put4xi>queue2one8shot2one28004xi</ack2put4xi>"
    else:
        message2send4one = "<nack2put4xi>queue2one8shot2one28004xi</nack2put4xi>" 
             
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        
        publisher_channel2one.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2800ONE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
            # SENT MESSAGE2SEND4ONE:  <ack2put4xi>queue2one8shot2one28004xi</ack2put4xi>  TO PUBLISHER_CHANNEL2ONE:  <read-write PipeConnection, handle 260>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time  
        
    except:
        print(" (STEP 3C/33) OF FIRE2800ONE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2800ONE4XI - RETURNING QUEUE OBJECT QUEUE2ONE: ", queue2one, " - TIME: ", time4xi())  
        # 
            
    return queue2one    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2800one4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
